> [!IMPORTANT]
> **Important:** New user roles and permissions will affect data returned by the AdMob API. [Learn more](https://support.google.com/admob/answer/2784628)

The AdMob API has the ability to generate the following reports:

Network report
:   The network report provides data on AdMob's performance and generates the
    same data found in the
    [AdMob UI network report](https://support.google.com/admob/answer/9005740).

Mediation report
:   The mediation report includes third-party performance. If you are unfamiliar
    with the mediation report, take a look at the
    [Help Center article](https://support.google.com/admob/answer/9005741).

## Dimensions

> [!NOTE]
> **Note:** Some dimensions and metrics are incompatible and will cause a conflict to arise in a single report. For additional information, see the [report reference documentation](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.networkReport/generate#dimension).

In reports, dimensions are used for grouping purposes, and if no dimensions are
specified, the report returns a single row of the requested metrics for the
entire account. Each report has various dimensions, see [network report](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.networkReport/generate#dimension)
and [mediation report dimensions](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.mediationReport/generate#dimension)
for more details.

Examples:

| Report type | Dimension | Description |
|---|---|---|
| Mediation report | [AD_SOURCE](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.mediationReport/generate#dimension) | The unique ID of the ad source (for example, "5450213213286189855" and "AdMob Network" as label value). |
| Network report | [AD_TYPE](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.networkReport/generate#dimension) | Type of the ad (for example, "text" or "image"). |

## Metrics

Metrics represent the different measurements you can make on that data. When a
report is requested, the metrics are calculated according to the chosen
dimensions. A report must include at least one metric. Each report has various
metrics, see [network report](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.networkReport/generate#metric)
and [mediation report metrics](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.mediationReport/generate#metric)
for more details.

Examples:

| Report type | Metric | Description |
|---|---|---|
| Mediation report | [OBSERVED_ECPM](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.mediationReport/generate#dimension) | The third-party ad network's estimated average eCPM. |
| Network report | [SHOW_RATE](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.networkReport/generate#metric) | The ratio of ads that are displayed over ads that are returned, defined as impressions / matched requests. The value is a double precision (approximate) decimal value. |

## Filters

Filters allow you to restrict the rows that get included in the report by
specifying a [dimension to filter](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.mediationReport/generate#dimensionfilter) on and the filter expression.

For example, the filter below can be applied to a mediation report to view
Meta Audience Network's performance. Take a look at the complete [list of ad sources](https://developers.google.com/admob/api/v1/ad-sources-reference)
that can be viewed in the mediation report.

| Dimension Filter | Filter Expression | Description |
|---|---|---|
| AD_SOURCE | matchesAny = {10568273599589928883} | Filters report rows based on [ad source](https://developers.google.com/admob/api/v1/ad-sources-reference). |

## Reduce report limits

Reports have a limit of 100,000 rows. When a report with over 100,000 rows is
requested, the report will be truncated and the first 100,000 rows will be
returned. See the [report response body](https://developers.google.com/admob/api/v1/reference/rest/v1/accounts.networkReport/generate#response-body)
for additional information on the response format.

To ensure you are receiving all rows, try reducing the size of the report by:

- Reducing the date range in the request.
- Reducing the number of dimensions as they act as a multiplier. Adding a dimension multiplies the number of rows, whereas adding a new metric to a report produces a new column.